//-----------------------------------------------------------------------------
// Credits
//-----------------------------------------------------------------------------
// Made by Lacry


//-----------------------------------------------------------------------------
// Variables
//-----------------------------------------------------------------------------

red_players <- []
red_players_left <- 0

has_round_started <- false
has_round_ended <- false

max_players <- MaxClients().tointeger()


//-----------------------------------------------------------------------------
// Functions
//-----------------------------------------------------------------------------

ClearGameEventCallbacks()

// Counts the players during the match
function count_players()
{
	if (!has_round_started || has_round_ended) return -1
	
	winner_logic()
	
	NetProps.SetPropInt(self, "m_nRedScore", red_players_left)
	
	return -1
}


// Logic when the round starts
function round_start()
{
	for (local i = 1; i <= max_players; i++)
	{
		local player = PlayerInstanceFromIndex(i)
		if (player == null || !is_player_valid(player)) continue
		
		if (player.GetTeam() == 2)
		{
			red_players.append(player)
		}
	}
	
	has_round_started = true
	
	return
}


function is_player_valid(player)
{
	return ((player.GetTeam() & 2))
}


// RED Player Counter
function add_red()
{
	red_players_left++
}

function rest_red()
{
	red_players_left--
}


// Sets Winner/Loser (By killing)
function winner_logic()
{
	if (red_players_left == 0)
	{
		DoEntFire("game_win_blue", "RoundWin", "", 0, null, null);
	}
	
	return
}


__CollectGameEventCallbacks(this)